;#
;# lx200hencoder - angle encoder for the PIC16F84A uC
;# Copyright (C) 2004  Hanno Rein (http://hanno-rein.de) 
;# 
;# This program is free software; you can redistribute it and/or
;# modify it under the terms of the GNU General Public License
;# as published by the Free Software Foundation; either version 2
;# of the License, or (at your option) any later version.
;# 
;# This program is distributed in the hope that it will be useful,
;# but WITHOUT ANY WARRANTY; without even the implied warranty of
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;# GNU General Public License for more details.
;# 
;# You should have received a copy of the GNU General Public License
;# along with this program; if not, write to the Free Software
;# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;# 
;#


    __CONFIG 		_PWRTE_ON & _WDT_OFF & _HS_OSC 
    list     		p=16f84a
    #include 		<P16f84.INC>

    ERRORLEVEL      -207 

; #############################################
; #####   Declarations                    #####
; #############################################
	mouseX			equ	0x20
	mouseY			equ	0x21
	mouseXPos		equ	0x22
	mouseYPos		equ	0x23
	mouseCalc		equ	0x24
	mouseXPosTemp	equ	0x25
	mouseYPosTemp	equ	0x26



	org 0
	goto init
	org 4	; interrupt
	retfie
	
; #############################################
; #####   Decode Table                    #####
; #############################################
	org	6
movement
	ANDLW	0x0F		 ; dont jump to far away
	addwf	PCL,f
	retlw	B'00000000'	 ; NC
	retlw	B'00000001'	 ; CW
	retlw	B'00000010'	 ; cCW
	retlw	B'00000000'	 ; Error (ignored)

	retlw	B'00000010'	 ; cCW
	retlw	B'00000000'	 ; NC
	retlw	B'00000000'	 ; Error (ignored)
	retlw	B'00000001'	 ; CW

	retlw	B'00000001'	 ; CW
	retlw	B'00000000'	 ; Error (ignored)	
	retlw	B'00000000'	 ; NC
	retlw	B'00000010'	 ; cCW

	retlw	B'00000000'	 ; Error (ignored)	
	retlw	B'00000010'	 ; cCW
	retlw	B'00000001'	 ; CW
	retlw	B'00000000'	 ; NC

	
; #############################################
; #####   Init                            #####
; #############################################
init:   
	clrf	PORTA
	clrf	PORTB
	bsf		STATUS,RP0	
	movlw	B'00001111'
	movwf	TRISA
	movlw	B'00111111'
	movwf	TRISB
	bcf		STATUS,RP0
	goto loop


; #############################################
; #####   Main Lopp                       #####
; #############################################
loop		; main loop



	rlf		mouseX,f
	rlf		mouseX,f
	movlw	B'00001100'
	ANDWF	mouseX,f		; clear now
	btfsc	PORTA,0
	bsf		mouseX,0
	btfsc	PORTA,1
	bsf		mouseX,1
	movfw	mouseX	
	Call	movement
	movwf	mouseCalc

	btfsc	PORTB,2
	goto 	invert1
		btfsc	mouseCalc,0
		bsf		PORTB,7
		btfsc	mouseCalc,1
		bcf		PORTB,7
	goto weiter3
	invert1:
		btfsc	mouseCalc,0
		bcf		PORTB,7
		btfsc	mouseCalc,1
		bsf		PORTB,7
	weiter3:
	TSTF	mouseCalc
	SKPNZ
	goto	weiter1
	bcf		PORTB,6
	bcf		PORTA,4
	nop
	nop
	nop
	bsf		PORTA,4
	weiter1:


	rlf		mouseY,f
	rlf		mouseY,f
	movlw	B'00001100'
	ANDWF	mouseY,f		; clear now
	btfsc	PORTA,2
	bsf		mouseY,0
	btfsc	PORTA,3
	bsf		mouseY,1
	movfw	mouseY	
	Call	movement
	movwf	mouseCalc

	btfsc	PORTB,3
	goto 	invert2
		btfsc	mouseCalc,0		;direction
		bsf		PORTB,7
		btfsc	mouseCalc,1
		bcf		PORTB,7	
	goto weiter4
	invert2:
		btfsc	mouseCalc,0		;direction
		bcf		PORTB,7
		btfsc	mouseCalc,1
		bsf		PORTB,7	
	weiter4:
	TSTF	mouseCalc
	SKPNZ
	goto	loop
	bsf		PORTB,6			;achse
	bcf		PORTA,4
	nop
	nop
	nop
	bsf		PORTA,4

	goto loop

; #############################################
; #####   that's it...                    #####
; #############################################
end
